program SVVClient_delphi;

{$APPTYPE CONSOLE}

uses
  SysUtils,
  ScktComp,
  Classes,
  igralec in 'igralec.pas',
  polje in 'polje.pas';

function readch(s: TStream): char;
var
  ch: char;
begin
  s.Read(ch, 1);
  readch := ch;
end;

function haveline(s: string): boolean;
begin
  if s[Length(s)] = #10 then haveline := true
  else haveline := false;
end;

procedure chopline(var s: string);
begin
  if s[Length(s)] = #10 then SetLength(s, Length(s)-1);
  if s[Length(s)] = #13 then SetLength(s, Length(s)-1);
end;

function readline(s: TStream): string;
var
  str: string;
begin
  str := '';
  repeat
    str := str + readch(s);
  until haveline(str);
  chopline(str);
  readline := str;
end;

procedure connect(hostname: string; var client: TClientSocket; var cstream: TWinSocketStream);
var
  server, succ: string;
begin
  client := TClientSocket.Create(nil);

  client.Port := 1177;
  client.Host := hostname;
  client.ClientType := ctBlocking;
  cstream := TWinSocketStream.Create(client.Socket, -1);
  client.Active := true;

  server := readline(cstream);
  WriteLn(server);

  client.Socket.SendText('AVE ' + TIgralec.getIme + #10);
  succ := readline(cstream);
  if succ <> 'PRIJAVA USPESNA' then raise Exception.Create('Napaka pri povezavi na streznik');
end;

procedure event_loop(client:TClientSocket; s: TWinSocketStream);
label adijo;
var
  cmd: string;
  cmda: TStringList;
  t: TIgralec;
  p: TPolje;
  w, h, z: Integer;
  prejsnja_poteza, poteza: Integer;
begin
  cmda := TStringList.Create;
  cmda.Delimiter := ' ';

  while true do begin
    cmd := readline(s);
    cmda.Clear;
    cmda.DelimitedText := cmd;

    if cmda.Strings[0] = 'ADIJO' then break;
    if cmda.Strings[0] = 'KONEC_IGRE' then continue;
    if cmda.Strings[0] <> 'ZBUDI_SE' then raise Exception.Create('Napaka pri komunikaciji s streznikom');

    w := StrToInt(cmda.Strings[1]);
    h := StrToInt(cmda.Strings[2]);
    z := StrToInt(cmda.Strings[3]);

    p := TPolje.Create(w, h);
    t := TIgralec.Create;
    t.ZbudiSe(w, h, z=0);

    client.Socket.SendText('BUDEN' + #10);

    while true do begin
      cmd := readline(s);
      cmda.Clear;
      cmda.DelimitedText := cmd;

      if cmda.Strings[0] = 'ADIJO' then goto adijo;
      if cmda.Strings[0] = 'KONEC_IGRE' then begin
        t.KonecIgre(razlog(StrToInt(cmda.Strings[1])));
        t.Free;
        p.Free;
        break;
      end else if cmda.Strings[0] = 'QV' then begin
        prejsnja_poteza := StrToInt(cmda.Strings[1]);
        p.dodaj(prejsnja_poteza, bNasprotnik);
        poteza := t.KamGres(TPolje(p), prejsnja_poteza);
        p.dodaj(poteza, bJaz);
        client.Socket.SendText('QVR ' + IntToStr(poteza)+ #10);
      end;
    end;
  end;
adijo:
end;

var
  client: TClientSocket;
  cstream: TWinSocketStream;
  hostname: string;

begin
  if ParamCount() < 2 then hostname:= 'localhost'
  else hostname := ParamStr(1);

  connect(hostname, client, cstream);
  event_loop(client, cstream);
end.

